=== external/pybind11/docs/requirements.txt ===
breathe==4.26.1
commonmark==0.9.1
recommonmark==0.7.1
sphinx==3.3.1
sphinx_rtd_theme==0.5.0
sphinxcontrib-moderncmakedomain==3.17
sphinxcontrib-svg2pdfconverter==1.1.0
