=== debian/changelog ===
wsclean (3.0-2build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 15 Jan 2022 09:07:15 +0000

wsclean (3.0-2build1) jammy; urgency=medium

  * No-change rebuild against

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 01:38:43 +0000

wsclean (3.0-2) unstable; urgency=medium

  * Don't try SIMD on non-x86 processors (not implemented yet)
  * Update project homepage

 -- Ole Streicher <olebole@debian.org>  Tue, 02 Nov 2021 08:25:55 +0100

wsclean (3.0-1) unstable; urgency=medium

  * Switch to gitlab.com. d/watch doesn't work anymore, however.
  * New upstream version 3.0. Closes: #997292
  * Rediff patches
  * Push Standards-Version to 4.6.0. No changes required
  * Adjust build dependencies
  * Don't build the shared library anymore
  * Remove outdated license statement

 -- Ole Streicher <olebole@debian.org>  Mon, 01 Nov 2021 09:27:20 +0100
